<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServiceSpecificItemIdentity ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfServiceSpecificItemIdentity
 * @subpackage Arrays
 */
class ArrayOfServiceSpecificItemIdentity extends AbstractStructArrayBase
{
    /**
     * The ServiceSpecificItemIdentity
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\ServiceSpecificItemIdentity[]
     */
    public $ServiceSpecificItemIdentity;
    /**
     * Constructor method for ArrayOfServiceSpecificItemIdentity
     * @uses ArrayOfServiceSpecificItemIdentity::setServiceSpecificItemIdentity()
     * @param \patest\StructType\ServiceSpecificItemIdentity[] $serviceSpecificItemIdentity
     */
    public function __construct(array $serviceSpecificItemIdentity = array())
    {
        $this
            ->setServiceSpecificItemIdentity($serviceSpecificItemIdentity);
    }
    /**
     * Get ServiceSpecificItemIdentity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\ServiceSpecificItemIdentity[]|null
     */
    public function getServiceSpecificItemIdentity()
    {
        return isset($this->ServiceSpecificItemIdentity) ? $this->ServiceSpecificItemIdentity : null;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceSpecificItemIdentity method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceSpecificItemIdentity method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceSpecificItemIdentityForArrayConstraintsFromSetServiceSpecificItemIdentity(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfServiceSpecificItemIdentityServiceSpecificItemIdentityItem) {
            // validation for constraint: itemType
            if (!$arrayOfServiceSpecificItemIdentityServiceSpecificItemIdentityItem instanceof \patest\StructType\ServiceSpecificItemIdentity) {
                $invalidValues[] = is_object($arrayOfServiceSpecificItemIdentityServiceSpecificItemIdentityItem) ? get_class($arrayOfServiceSpecificItemIdentityServiceSpecificItemIdentityItem) : sprintf('%s(%s)', gettype($arrayOfServiceSpecificItemIdentityServiceSpecificItemIdentityItem), var_export($arrayOfServiceSpecificItemIdentityServiceSpecificItemIdentityItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceSpecificItemIdentity property can only contain items of type \patest\StructType\ServiceSpecificItemIdentity, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceSpecificItemIdentity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\ServiceSpecificItemIdentity[] $serviceSpecificItemIdentity
     * @return \patest\ArrayType\ArrayOfServiceSpecificItemIdentity
     */
    public function setServiceSpecificItemIdentity(array $serviceSpecificItemIdentity = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceSpecificItemIdentityArrayErrorMessage = self::validateServiceSpecificItemIdentityForArrayConstraintsFromSetServiceSpecificItemIdentity($serviceSpecificItemIdentity))) {
            throw new \InvalidArgumentException($serviceSpecificItemIdentityArrayErrorMessage, __LINE__);
        }
        if (is_null($serviceSpecificItemIdentity) || (is_array($serviceSpecificItemIdentity) && empty($serviceSpecificItemIdentity))) {
            unset($this->ServiceSpecificItemIdentity);
        } else {
            $this->ServiceSpecificItemIdentity = $serviceSpecificItemIdentity;
        }
        return $this;
    }
    /**
     * Add item to ServiceSpecificItemIdentity value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\ServiceSpecificItemIdentity $item
     * @return \patest\ArrayType\ArrayOfServiceSpecificItemIdentity
     */
    public function addToServiceSpecificItemIdentity(\patest\StructType\ServiceSpecificItemIdentity $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\ServiceSpecificItemIdentity) {
            throw new \InvalidArgumentException(sprintf('The ServiceSpecificItemIdentity property can only contain items of type \patest\StructType\ServiceSpecificItemIdentity, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceSpecificItemIdentity[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\ServiceSpecificItemIdentity|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\ServiceSpecificItemIdentity|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\ServiceSpecificItemIdentity|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\ServiceSpecificItemIdentity|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\ServiceSpecificItemIdentity|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceSpecificItemIdentity
     */
    public function getAttributeName()
    {
        return 'ServiceSpecificItemIdentity';
    }
}
